#include "redica.h"
#include<bits/stdc++.h>
using namespace std;
int s=0;
int k;
int n;
int su;
void genr(int l,vector<int>v)
{
    if(l==n-1)
    {
        if(su-s>k)return;
        v.push_back(su-s);
        submit(v);
        v.pop_back();
        return;
    }
    for(int i=1;i<=k;i++)
    {
        v.push_back(i);
        s+=i;
        if(s>su)
        {
            s-=i;
            return;
        }
        genr(l+1,v);
        s-=i;
        v.pop_back();
    }
}
void solve(int N, int K, int S)
{
    n=N;
    k=K;
    su=S;
    vector<int>v;
    int h;
    int br=6;
    if(n<=7)br=0;
    for(int i=1;i<=min(br,n);i++)
    {
        h=query();
        s+=h;
        v.push_back(h);
    }
    if(br>=n)submit(v);
    genr(br,v);
    return;
}
